do
    local brk = dat.brk
    dat.brk = nil
    local port = dat.port
    dat.port = nil
    local subscribe, merror, newm, mconnect
    
    function subscribe(con)
        print("Connected")
        dat.broker = true
        con:subscribe(dat.clnt.."/com/#", 0)
        con:publish(dat.clnt..'/state', "ON", 0, 1)
        print("Subscribed")
    end
    
    function merror(con, reason)
        print('Function Error! Heap: ', node.heap())
        con = nil
        reason = nil
        m = nil
        collectgarbage()
       tmr.create():alarm(10000, tmr.ALARM_SINGLE, function(t) 
            t = nil 
            mconnect(newm()) 
        end)
    end

    function newm()
        m = mqtt.Client(dat.clnt, 25, dat.clnt, 'pass22')
        m:lwt(dat.clnt..'/state', "OFF", 0, 1)
        m:on("offline", function(con)
            con:close()
            dat.broker = false
            print("Offline")
            merror(con)
        end)
        m:on("message", function(con, top, dt)
            if not killtop then killtop = {} end
            top = string.match(top, "/(%w+)$")
            print('Got', top, dt)
            if dt then
                table.insert(killtop, {top, dt})
                if not dat.analiz then
                    dofile("mqttanalize.lua")
                end
            end
        end)
        return m
    end
 
    function mconnect(con)
        con:connect(brk, port, false, subscribe, merror)
    end
    mconnect(newm())
end